/* ============================================================================================== *
 *                                                                                                *
 *                                       Xi Blockchain                                            *
 *                                                                                                *
 * ---------------------------------------------------------------------------------------------- *
 * This file is part of the Galaxia Project - Xi Blockchain                                       *
 * ---------------------------------------------------------------------------------------------- *
 *                                                                                                *
 * Copyright 2018-2019 Galaxia Project Developers                                                 *
 *                                                                                                *
 * This program is free software: you can redistribute it and/or modify it under the terms of the *
 * GNU General Public License as published by the Free Software Foundation, either version 3 of   *
 * the License, or (at your option) any later version.                                            *
 *                                                                                                *
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;      *
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
 * See the GNU General Public License for more details.                                           *
 *                                                                                                *
 * You should have received a copy of the GNU General Public License along with this program.     *
 * If not, see <https://www.gnu.org/licenses/>.                                                   *
 *                                                                                                *
 * ============================================================================================== */

#include <gmock/gmock.h>

#include <Xi/Rct/Constants.h>
#include <Xi/Rct/Algorithm/KeyArithmetic.h>

#define XI_TESTSUITE T_Xi_Rct_KeyArithmetic

TEST(XI_TESTSUITE, HConstantScalar) {
  using namespace ::testing;
  using namespace ::Xi;
  using namespace ::Xi::Rct;

  std::vector<std::pair<KeyVector, Rct::Key>> Oracle{
      {{{{{0x70, 0x17, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0,  0x0,  0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
        {{0xcb, 0x3e, 0xe3, 0x24, 0xab, 0xba, 0xf6, 0x8d, 0xa4, 0x32, 0x78, 0xb7, 0x12, 0x7e, 0x79, 0x6d,
          0x91, 0xb5, 0xcd, 0x58, 0x9a, 0xd4, 0x6,  0x2e, 0xf8, 0x7c, 0x3d, 0x20, 0xeb, 0x8b, 0x51, 0x45}}},
       {{{{0x58, 0x1b, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0,  0x0,  0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
        {{0xeb, 0xda, 0xec, 0x3,  0xd7, 0x8a, 0x5d, 0x93, 0x4c, 0xde, 0x2a, 0x24, 0xe4, 0x36, 0x7c, 0x33,
          0xff, 0xec, 0xf1, 0xdf, 0x23, 0xff, 0x5d, 0xf3, 0xa5, 0xdc, 0x8d, 0x15, 0xe4, 0x55, 0xb2, 0x9b}}},
       {{{{0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
        {{0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
          0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
       {{{{0x71, 0x17, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0,  0x0,  0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
        {{0x6c, 0xf3, 0x38, 0xb7, 0xaa, 0xf1, 0x7b, 0x13, 0x81, 0xed, 0xbb, 0xcf, 0x6,  0x10, 0x94, 0xe0,
          0xa3, 0xac, 0x64, 0x55, 0x3e, 0xe2, 0x60, 0xe1, 0x82, 0xcb, 0x21, 0x81, 0xe9, 0x86, 0x5d, 0x5f}}},
       {{{{0x58, 0x1b, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0,  0x0,  0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
        {{0xeb, 0xda, 0xec, 0x3,  0xd7, 0x8a, 0x5d, 0x93, 0x4c, 0xde, 0x2a, 0x24, 0xe4, 0x36, 0x7c, 0x33,
          0xff, 0xec, 0xf1, 0xdf, 0x23, 0xff, 0x5d, 0xf3, 0xa5, 0xdc, 0x8d, 0x15, 0xe4, 0x55, 0xb2, 0x9b}}},
       {{{{0xd4, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0,  0x0,  0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
        {{0xf8, 0x9a, 0xb3, 0xc7, 0x5d, 0xba, 0x7d, 0xca, 0xbe, 0xaa, 0xc7, 0x50, 0x9a, 0xc8, 0xd2, 0xda,
          0xd2, 0xf5, 0x96, 0x79, 0x4a, 0xf7, 0xef, 0x72, 0x8,  0x22, 0x56, 0x40, 0x4e, 0x12, 0xa9, 0x3b}}},
       {{{{0xd4, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0,  0x0,  0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
        {{0xf8, 0x9a, 0xb3, 0xc7, 0x5d, 0xba, 0x7d, 0xca, 0xbe, 0xaa, 0xc7, 0x50, 0x9a, 0xc8, 0xd2, 0xda,
          0xd2, 0xf5, 0x96, 0x79, 0x4a, 0xf7, 0xef, 0x72, 0x8,  0x22, 0x56, 0x40, 0x4e, 0x12, 0xa9, 0x3b}}},
       {{{{0xd4, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0,  0x0,  0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
        {{0xf8, 0x9a, 0xb3, 0xc7, 0x5d, 0xba, 0x7d, 0xca, 0xbe, 0xaa, 0xc7, 0x50, 0x9a, 0xc8, 0xd2, 0xda,
          0xd2, 0xf5, 0x96, 0x79, 0x4a, 0xf7, 0xef, 0x72, 0x8,  0x22, 0x56, 0x40, 0x4e, 0x12, 0xa9, 0x3b}}},
       {{{{0xd4, 0x30, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
           0x0,  0x0,  0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0}}},
        {{0xf8, 0x9a, 0xb3, 0xc7, 0x5d, 0xba, 0x7d, 0xca, 0xbe, 0xaa, 0xc7, 0x50, 0x9a, 0xc8, 0xd2, 0xda,
          0xd2, 0xf5, 0x96, 0x79, 0x4a, 0xf7, 0xef, 0x72, 0x8,  0x22, 0x56, 0x40, 0x4e, 0x12, 0xa9, 0x3b}}}}};

  for (const auto& oracle : Oracle) {
    const auto& input = oracle.first;
    const auto& expected = oracle.second;
    auto returnVariant = key_multiply_scalar_with_h_constant(input.front());
    Rct::Key inplaceVariant;
    key_multiply_scalar_with_h_constant_inplace(input.front(), inplaceVariant);
    EXPECT_EQ(returnVariant, expected);
    EXPECT_EQ(inplaceVariant, expected);
  }
}
